import { Batch, Key, KeyQuery, Pair, Query } from 'interface-datastore';
import { BaseDatastore } from 'datastore-core';
import { Level } from 'level';
import type { DatabaseOptions, OpenOptions } from 'level';
/**
 * A datastore backed by leveldb
 */
export declare class LevelDatastore extends BaseDatastore {
    db: Level<string, Uint8Array>;
    private readonly opts;
    constructor(path: string | Level<string, Uint8Array>, opts?: DatabaseOptions<string, Uint8Array> & OpenOptions);
    open(): Promise<void>;
    put(key: Key, value: Uint8Array): Promise<void>;
    get(key: Key): Promise<Uint8Array>;
    has(key: Key): Promise<boolean>;
    delete(key: Key): Promise<void>;
    close(): Promise<void>;
    batch(): Batch;
    query(q: Query): AsyncIterable<Pair>;
    queryKeys(q: KeyQuery): AsyncIterable<Key>;
    _query(opts: {
        values: boolean;
        prefix?: string;
    }): AsyncIterable<Pair>;
}
//# sourceMappingURL=index.d.ts.map